/*
 * 	Doku, siehe http://www.mikrocontroller.net/articles/AVR_FAT32
 *  Neuste Version: http://www.mikrocontroller.net/svnbrowser/avr-fat32/
 *	Autor: Daniel R.
 */



#ifndef _FAT_H
  #define _FAT_H

	// #######################################################################################################################
	// "daten" ketten siehe doku...
	// 1. fat_getFreeRowOfCluster -> fat_getFreeRowOfDir -> fat_makeRowDataEntry -> fat_makeFileEntry -> fat_writeSector  "eintrag gemacht !!"
	// 2. fat_loadSector -> fat_loadRowOfSector -> fat_loadFileDataFromCluster -> fat_loadFileDataFromDir (-> fat_cd)   "daten chain"

	// #######################################################################################################################
	// funktionen

  extern unsigned long int fat_clustToSec(unsigned long int);				// rechnet cluster zu 1. sektor des clusters um
  extern unsigned long int fat_secToClust(unsigned long int sec);			// rechnet sektor zu cluster um!
  extern unsigned long int fat_getNextCluster(unsigned long int oneCluster);// fat auf naechsten, verketteten cluster durchsuchen
  extern unsigned long long int fat_getFreeBytes(void);						// berechnet den freien platz der karte in bytes!
  extern unsigned char 	fat_writeSector(unsigned long int sec);				// schreibt sektor auf karte
  extern unsigned char 	fat_loadSector(unsigned long int sec);				// laed Uebergebenen absoluten sektor
  extern unsigned char 	fat_loadFileDataFromDir( unsigned char name []);	// durchsucht das aktuelle directory
  extern unsigned char	fat_loadFatData(void);								// laed fat daten
  extern void 				fat_loadRowOfSector(unsigned short row);			// laed reihe des geladen sektors auf struct:file
  extern void 				fat_setCluster( unsigned long int cluster, unsigned long int content); 	// setzt cluster inhalt in der fat
  extern void 				fat_delClusterChain(unsigned long int startCluster);			// loescht cluster-chain in der fat
  extern void 				fat_makeFileEntry( unsigned char name [],unsigned char attrib); // macht einen datei/ordner eintrag
  extern void 				fat_getFreeClustersInRow(unsigned long int offsetCluster);		// sucht zusammenhaengende freie cluster aus der fat
  extern void 				fat_getFatChainClustersInRow( unsigned long int offsetCluster);	// sucht fat-chain cluster die zusammenhaengen
  extern void 				fat_setClusterChain(unsigned long int startCluster, unsigned long int endCluster); // verkettet cluster zu einer cluster-chain
  void 						fat_makeSfnDataEntry(unsigned char name [],unsigned char attrib,unsigned long int cluster,unsigned long int length);

  // #######################################################################################################################
  // variablen



#endif


 



